// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/PartValidator.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class PartValidator extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0, 0
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\34\u0200\1\u0300\1\u0200\1\u0400\1\u0500\266\u0200"+
    "\10\u0600\u1020\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\3\1\4\1\5\22\0\1\6"+
    "\5\0\1\7\2\0\1\10\4\0\1\11\1\0\1\12"+
    "\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22"+
    "\1\23\1\24\1\25\1\26\1\0\1\27\2\0\1\30"+
    "\1\31\1\32\1\33\1\34\1\35\1\36\1\37\1\40"+
    "\1\41\1\42\1\43\1\44\1\45\1\46\1\47\1\50"+
    "\1\51\1\52\1\53\1\54\1\55\1\56\1\57\1\60"+
    "\1\61\3\0\1\62\2\0\1\63\1\64\1\65\1\66"+
    "\1\67\1\70\1\71\1\72\1\73\1\74\1\75\1\76"+
    "\1\77\1\100\1\101\1\102\1\103\1\104\1\105\1\106"+
    "\1\107\1\110\1\111\1\112\1\113\1\114\12\0\1\3"+
    "\44\0\1\62\5\0\1\62\11\0\1\62\5\0\6\115"+
    "\1\0\11\115\1\0\6\115\2\0\4\115\3\0\6\115"+
    "\1\0\11\115\1\0\6\115\2\0\4\115\53\0\2\115"+
    "\6\0\2\116\66\0\2\115\4\0\2\115\17\0\1\117"+
    "\u0188\0\2\115\216\0\2\115\42\0\2\115\104\0\1\1"+
    "\45\0\2\3\u0100\0\1\120\325\0\u0100\3";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1792];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\0\1\1\1\2\1\1\12\3\3\1\1\4\5\1"+
    "\1\4\2\1\1\4\11\1\1\4\1\1\1\4\36\1"+
    "\2\0\12\3\1\5\6\3\1\6\1\7\1\10\1\11"+
    "\1\12\1\13\1\14\1\15\10\0\2\4\12\0\1\4"+
    "\3\0\2\4\27\0\2\4\3\0\1\4\3\0\4\16"+
    "\1\17\2\0\1\16\1\0\2\16\2\0\1\16\2\0"+
    "\1\16\2\0\1\20\1\21\1\22\1\23\1\24\1\25"+
    "\1\26\1\27\1\30\1\31\1\32\1\33\1\34\1\35"+
    "\1\36\1\37\3\0\1\40\1\0\1\4\26\0\1\41"+
    "\5\0\1\4\1\0\1\42\4\0\1\43\1\0\1\43"+
    "\11\0\1\15\40\0\1\4\5\0\1\44\36\0\1\45"+
    "\31\0\1\46\6\0\2\47\2\0\1\50\1\0\1\10"+
    "\1\51\17\0\1\52\16\0\1\53\17\0\1\50\3\0"+
    "\1\51\17\0\1\54\1\52\52\0\1\55\4\0\1\54"+
    "\7\0\1\56\2\0\1\57\15\0\1\60\1\61\5\0"+
    "\1\62\13\0\1\63\7\0\1\64\1\0\1\65\20\0"+
    "\1\66\2\0\1\67\5\0\1\70\1\0\1\63\4\0"+
    "\1\71\3\0\1\72\43\0\1\73\1\0\1\74\26\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[620];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\121\0\242\0\363\0\u0144\0\u0195\0\u01e6\0\u0237"+
    "\0\u0288\0\u02d9\0\u032a\0\u037b\0\u03cc\0\u041d\0\u046e\0\u04bf"+
    "\0\u0510\0\u0561\0\u05b2\0\u0603\0\u0654\0\u06a5\0\u06f6\0\u0747"+
    "\0\u0798\0\u07e9\0\u083a\0\u088b\0\u08dc\0\u092d\0\u097e\0\u09cf"+
    "\0\u0a20\0\u0a71\0\u0ac2\0\u0b13\0\u0b64\0\u0bb5\0\u0c06\0\u0c57"+
    "\0\u0ca8\0\u0cf9\0\u0d4a\0\u0d9b\0\u0dec\0\u0e3d\0\u0e8e\0\u0edf"+
    "\0\u0f30\0\u0f81\0\u0fd2\0\u1023\0\u1074\0\u10c5\0\u1116\0\u1167"+
    "\0\u11b8\0\u1209\0\u125a\0\u12ab\0\u12fc\0\u134d\0\u139e\0\u13ef"+
    "\0\u1440\0\u1491\0\u14e2\0\u1533\0\u1584\0\363\0\u15d5\0\u1626"+
    "\0\u1677\0\u16c8\0\u1719\0\u176a\0\u17bb\0\u180c\0\u185d\0\u18ae"+
    "\0\u18ff\0\121\0\u1950\0\u19a1\0\u19f2\0\u1a43\0\u1a94\0\u1ae5"+
    "\0\121\0\121\0\121\0\121\0\121\0\121\0\121\0\121"+
    "\0\u1b36\0\u1b87\0\u1bd8\0\u1c29\0\u1c7a\0\u1ccb\0\u1d1c\0\u1d6d"+
    "\0\u1dbe\0\u1e0f\0\u1e60\0\u1eb1\0\u1f02\0\u1f53\0\u1fa4\0\u1ff5"+
    "\0\u2046\0\u2097\0\u20e8\0\u2139\0\u218a\0\u21db\0\u222c\0\u227d"+
    "\0\u22ce\0\u231f\0\u2370\0\u23c1\0\u2412\0\u2463\0\u24b4\0\u2505"+
    "\0\u2556\0\u25a7\0\u25f8\0\u2649\0\u269a\0\u26eb\0\u273c\0\u278d"+
    "\0\u27de\0\u282f\0\u2880\0\u28d1\0\u2922\0\u2973\0\u29c4\0\u2a15"+
    "\0\u2a66\0\u2ab7\0\u2b08\0\u2b59\0\u2baa\0\u2bfb\0\u2c4c\0\u2c9d"+
    "\0\u2cee\0\u2d3f\0\121\0\u2d90\0\u1bd8\0\u1d1c\0\121\0\u2de1"+
    "\0\u2e32\0\u1f53\0\u2e83\0\u21db\0\u227d\0\u2ed4\0\u2f25\0\u282f"+
    "\0\u2f76\0\u2fc7\0\u2b59\0\u3018\0\u3069\0\121\0\121\0\121"+
    "\0\121\0\121\0\121\0\121\0\121\0\121\0\121\0\121"+
    "\0\121\0\121\0\121\0\121\0\121\0\u30ba\0\u310b\0\u315c"+
    "\0\u31ad\0\u31fe\0\u324f\0\u32a0\0\u32f1\0\u3342\0\u3393\0\u33e4"+
    "\0\u3435\0\u3486\0\u34d7\0\u3528\0\u3579\0\u35ca\0\u361b\0\u366c"+
    "\0\u36bd\0\u370e\0\u375f\0\u37b0\0\u3801\0\u3852\0\u38a3\0\u38f4"+
    "\0\u3945\0\u3996\0\u39e7\0\u3a38\0\u3a89\0\u3ada\0\u3b2b\0\u3b7c"+
    "\0\u3bcd\0\121\0\u3c1e\0\u3c6f\0\u3cc0\0\u3d11\0\121\0\u3d62"+
    "\0\u3db3\0\u3e04\0\u31ad\0\u3e55\0\u3ea6\0\u3ef7\0\u3f48\0\u3f99"+
    "\0\u3fea\0\u403b\0\u408c\0\u40dd\0\u412e\0\u417f\0\u41d0\0\u4221"+
    "\0\u4272\0\u42c3\0\u4314\0\u4365\0\u43b6\0\u4407\0\u4458\0\u44a9"+
    "\0\u44fa\0\u454b\0\u459c\0\u45ed\0\u463e\0\u468f\0\u46e0\0\u4731"+
    "\0\u4782\0\u47d3\0\u4824\0\u4875\0\u48c6\0\u4917\0\u4968\0\u49b9"+
    "\0\u4a0a\0\u4a5b\0\u4aac\0\u4afd\0\u4b4e\0\u4b9f\0\u4bf0\0\u4c41"+
    "\0\u4c92\0\121\0\u4ce3\0\u3db3\0\u4d34\0\u4d85\0\u4dd6\0\u4e27"+
    "\0\u4e78\0\u4ec9\0\u4f1a\0\u4f6b\0\u4fbc\0\u500d\0\u505e\0\u50af"+
    "\0\u5100\0\u5151\0\u51a2\0\u51f3\0\u5244\0\u5295\0\u52e6\0\u5337"+
    "\0\u5388\0\u53d9\0\u542a\0\u547b\0\u54cc\0\u551d\0\u556e\0\u55bf"+
    "\0\u5610\0\u5661\0\u56b2\0\u5703\0\u5754\0\u57a5\0\u57f6\0\u5847"+
    "\0\u5898\0\u58e9\0\u593a\0\u598b\0\u59dc\0\u5a2d\0\u5a7e\0\u5acf"+
    "\0\u5b20\0\u5b71\0\u5bc2\0\u5c13\0\u5c64\0\u5cb5\0\u5d06\0\u5d57"+
    "\0\u5da8\0\u5df9\0\121\0\u5e4a\0\u5e9b\0\u5eec\0\u5f3d\0\u5f8e"+
    "\0\u5fdf\0\121\0\u6030\0\u6081\0\u60d2\0\u6123\0\u6174\0\u61c5"+
    "\0\u6216\0\u6267\0\u62b8\0\u6309\0\u635a\0\u63ab\0\u63fc\0\u644d"+
    "\0\u649e\0\u64ef\0\u5610\0\u6540\0\u6591\0\u65e2\0\u6633\0\u6684"+
    "\0\u55bf\0\u66d5\0\u6726\0\u6777\0\u67c8\0\u6819\0\u686a\0\u68bb"+
    "\0\u690c\0\u695d\0\u69ae\0\u69ff\0\u6a50\0\u6aa1\0\u6af2\0\u6b43"+
    "\0\u6b94\0\u6be5\0\u6c36\0\u6c87\0\u6cd8\0\u6d29\0\u6d7a\0\u6dcb"+
    "\0\u6e1c\0\u6e6d\0\u6ebe\0\u6f0f\0\u6030\0\u6f60\0\u6fb1\0\121"+
    "\0\u6123\0\u7002\0\u7053\0\121\0\u6216\0\u70a4\0\u70f5\0\u7146"+
    "\0\u7197\0\u71e8\0\u7239\0\u728a\0\u72db\0\u732c\0\u737d\0\u73ce"+
    "\0\u741f\0\u7470\0\u74c1\0\u7512\0\121\0\u7563\0\u75b4\0\u7605"+
    "\0\u7656\0\u76a7\0\u76f8\0\u7749\0\u779a\0\u77eb\0\u783c\0\u788d"+
    "\0\u78de\0\u792f\0\u6b43\0\u7980\0\u79d1\0\u7a22\0\u7a73\0\u7ac4"+
    "\0\u7b15\0\u7b66\0\u7bb7\0\u7c08\0\u7c59\0\u7caa\0\u7cfb\0\u7d4c"+
    "\0\u7d9d\0\u7dee\0\u7e3f\0\u7e90\0\u7ee1\0\u7f32\0\u7f83\0\u7fd4"+
    "\0\u8025\0\u8076\0\u80c7\0\u8118\0\u8169\0\u81ba\0\u820b\0\121"+
    "\0\u825c\0\u82ad\0\u82fe\0\u834f\0\121\0\u7512\0\u83a0\0\u83f1"+
    "\0\u8442\0\u8493\0\u84e4\0\u8535\0\121\0\u8586\0\u85d7\0\121"+
    "\0\u8628\0\u8679\0\u86ca\0\u871b\0\u876c\0\u87bd\0\u880e\0\u885f"+
    "\0\u88b0\0\u8901\0\u8952\0\u89a3\0\u89f4\0\121\0\121\0\u8a45"+
    "\0\u8a96\0\u8ae7\0\u8b38\0\u8b89\0\121\0\u8bda\0\u8c2b\0\u8c7c"+
    "\0\u8ccd\0\u8d1e\0\u8d6f\0\u8dc0\0\u8e11\0\u8e62\0\u8eb3\0\u8f04"+
    "\0\u8f55\0\u8fa6\0\u8ff7\0\u9048\0\u9099\0\u90ea\0\u913b\0\u918c"+
    "\0\121\0\u91dd\0\121\0\u922e\0\u927f\0\u92d0\0\u9321\0\u9372"+
    "\0\u93c3\0\u9414\0\u9465\0\u94b6\0\u9507\0\u9558\0\u95a9\0\u95fa"+
    "\0\u964b\0\u969c\0\u96ed\0\121\0\u973e\0\u978f\0\121\0\u97e0"+
    "\0\u9831\0\u9882\0\u98d3\0\u9924\0\121\0\u9975\0\u99c6\0\u8f55"+
    "\0\u9a17\0\u9a68\0\u9ab9\0\121\0\u9b0a\0\u9b5b\0\u9bac\0\121"+
    "\0\u9bfd\0\u9c4e\0\u9c9f\0\u9cf0\0\u9d41\0\u9d92\0\u9de3\0\u9e34"+
    "\0\u9e85\0\u9ed6\0\u9f27\0\u9f78\0\u9fc9\0\ua01a\0\ua06b\0\ua0bc"+
    "\0\ua10d\0\ua15e\0\ua1af\0\ua200\0\ua251\0\u99c6\0\ua2a2\0\ua2f3"+
    "\0\ua344\0\ua395\0\ua3e6\0\ua437\0\ua488\0\ua4d9\0\ua52a\0\ua57b"+
    "\0\ua5cc\0\ua61d\0\ua66e\0\121\0\ua6bf\0\121\0\ua710\0\ua761"+
    "\0\ua7b2\0\ua803\0\ua854\0\ua8a5\0\ua8f6\0\ua947\0\ua998\0\ua9e9"+
    "\0\uaa3a\0\uaa8b\0\uaadc\0\uab2d\0\uab7e\0\uabcf\0\uac20\0\uac71"+
    "\0\uacc2\0\uad13\0\uad64\0\uadb5";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[620];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\2\2\3\1\2\3\3\1\4\2\2\1\5\1\6"+
    "\1\7\1\10\1\11\1\12\1\13\1\14\1\15\1\16"+
    "\2\2\1\17\1\2\1\20\1\21\1\22\1\23\1\24"+
    "\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\2\1\52\1\53"+
    "\1\54\1\55\1\56\1\57\1\60\1\61\1\62\1\63"+
    "\1\64\1\65\1\66\1\67\1\70\1\71\1\72\1\73"+
    "\1\74\1\75\1\76\1\77\1\100\1\101\1\102\1\103"+
    "\1\2\1\104\1\105\1\32\122\0\2\3\1\0\3\3"+
    "\1\106\156\0\1\107\32\0\1\107\32\0\12\5\107\0"+
    "\1\110\1\111\1\112\1\113\1\114\1\115\1\116\1\117"+
    "\1\120\1\121\36\0\2\122\15\0\1\122\31\0\1\123"+
    "\1\124\1\125\1\126\1\127\1\130\4\5\36\0\2\131"+
    "\15\0\1\131\31\0\12\5\36\0\2\132\15\0\1\132"+
    "\31\0\12\5\36\0\2\133\15\0\1\133\31\0\12\5"+
    "\36\0\2\134\15\0\1\134\31\0\12\5\36\0\2\135"+
    "\15\0\1\135\31\0\12\5\36\0\2\136\15\0\1\136"+
    "\31\0\12\5\36\0\2\137\15\0\1\137\31\0\12\5"+
    "\36\0\2\140\15\0\1\140\56\0\1\141\32\0\1\141"+
    "\56\0\1\142\12\143\1\144\5\143\1\145\10\143\1\0"+
    "\1\142\12\143\1\144\5\143\1\145\10\143\1\0\3\143"+
    "\30\0\1\143\1\146\6\143\1\147\21\143\1\0\1\143"+
    "\1\146\6\143\1\147\21\143\1\0\1\147\2\143\30\0"+
    "\1\150\1\0\1\151\5\0\1\152\2\0\1\152\11\0"+
    "\1\152\1\0\1\152\3\0\1\150\1\0\1\153\66\0"+
    "\1\154\1\155\3\0\1\156\5\0\1\157\5\0\1\160"+
    "\11\0\1\154\1\155\3\0\1\156\5\0\1\157\5\0"+
    "\1\160\6\0\1\156\36\0\1\161\32\0\1\161\66\0"+
    "\1\162\32\0\1\162\66\0\1\163\32\0\1\163\66\0"+
    "\1\164\32\0\1\164\60\0\1\152\5\0\1\165\2\0"+
    "\1\152\11\0\1\152\1\0\1\152\13\0\1\166\22\0"+
    "\1\166\43\0\1\167\32\0\1\167\66\0\1\170\32\0"+
    "\1\170\22\0\1\170\32\0\1\152\5\0\1\171\2\0"+
    "\1\172\11\0\1\152\1\0\1\152\13\0\1\173\2\0"+
    "\1\174\17\0\1\173\46\0\1\175\32\0\1\175\66\0"+
    "\1\176\1\177\31\0\1\176\1\177\51\0\1\200\13\0"+
    "\1\201\4\0\1\202\11\0\1\200\13\0\1\201\4\0"+
    "\1\202\42\0\1\203\16\0\1\204\1\0\1\205\11\0"+
    "\1\203\16\0\1\204\1\0\1\205\64\0\1\206\3\0"+
    "\1\207\26\0\1\206\3\0\1\207\62\0\1\210\32\0"+
    "\1\210\50\0\1\211\15\0\1\212\14\0\1\211\15\0"+
    "\1\212\11\0\1\212\35\0\1\213\3\0\1\214\10\0"+
    "\1\215\1\0\1\216\13\0\1\213\3\0\1\214\10\0"+
    "\1\215\1\0\1\216\7\0\1\214\47\0\1\217\6\0"+
    "\1\220\23\0\1\217\6\0\1\220\43\0\1\152\1\0"+
    "\1\221\3\0\1\222\2\0\1\152\11\0\1\223\1\0"+
    "\1\152\7\0\1\221\3\0\1\224\14\0\1\225\5\0"+
    "\1\224\60\0\1\226\32\0\1\226\41\0\1\152\5\0"+
    "\1\152\2\0\1\152\11\0\1\152\1\0\1\227\32\0"+
    "\1\230\66\0\1\231\32\0\1\231\66\0\1\232\32\0"+
    "\1\232\4\0\5\233\1\234\22\233\1\142\12\143\1\144"+
    "\16\143\1\233\1\142\12\143\1\144\16\143\1\0\3\235"+
    "\5\233\1\234\22\233\1\143\1\146\6\143\1\147\21\143"+
    "\1\233\1\143\1\146\6\143\1\147\21\143\1\0\1\236"+
    "\2\235\5\233\1\234\2\233\2\237\16\233\2\0\1\153"+
    "\27\0\1\233\2\0\1\240\5\0\1\241\2\0\1\241"+
    "\11\0\1\241\1\0\1\241\3\0\10\233\1\234\22\233"+
    "\3\0\1\154\1\155\3\0\1\156\5\0\1\157\5\0"+
    "\1\160\5\0\1\233\3\0\1\154\1\155\3\0\1\156"+
    "\5\0\1\157\5\0\1\160\6\0\1\242\7\233\1\234"+
    "\22\233\4\0\1\161\25\0\1\233\4\0\1\161\26\0"+
    "\10\233\1\234\22\233\5\0\1\162\24\0\1\233\5\0"+
    "\1\162\25\0\10\233\1\234\22\233\6\0\1\163\23\0"+
    "\1\233\6\0\1\163\24\0\10\233\1\234\22\233\7\0"+
    "\1\164\22\0\1\233\7\0\1\164\23\0\10\233\1\234"+
    "\2\233\2\237\16\233\10\0\1\166\21\0\1\233\2\0"+
    "\1\241\5\0\1\243\2\0\1\241\11\0\1\241\1\0"+
    "\1\241\3\0\1\244\7\233\1\234\22\233\11\0\1\167"+
    "\20\0\1\233\11\0\1\167\21\0\10\233\1\234\22\233"+
    "\12\0\1\170\17\0\1\233\12\0\1\170\20\0\2\233"+
    "\1\245\5\233\1\234\2\233\2\237\16\233\13\0\1\174"+
    "\16\0\1\233\2\0\1\241\5\0\1\241\2\0\1\246"+
    "\11\0\1\241\1\0\1\241\3\0\10\233\1\234\22\233"+
    "\14\0\1\175\15\0\1\233\14\0\1\175\16\0\10\233"+
    "\1\234\22\233\15\0\1\176\1\177\13\0\1\233\15\0"+
    "\1\176\1\177\14\0\10\233\1\234\22\233\2\0\1\200"+
    "\13\0\1\201\4\0\1\202\6\0\1\233\2\0\1\200"+
    "\13\0\1\201\4\0\1\202\7\0\10\233\1\234\22\233"+
    "\17\0\1\204\1\0\1\205\10\0\1\233\17\0\1\204"+
    "\1\0\1\205\11\0\10\233\1\234\22\233\20\0\1\206"+
    "\3\0\1\207\5\0\1\233\20\0\1\206\3\0\1\207"+
    "\6\0\10\233\1\234\22\233\21\0\1\210\10\0\1\233"+
    "\21\0\1\210\11\0\10\233\1\234\22\233\4\0\1\247"+
    "\15\0\1\212\7\0\1\233\4\0\1\247\15\0\1\212"+
    "\10\0\1\233\1\250\6\233\1\234\22\233\4\0\1\213"+
    "\14\0\1\215\1\0\1\216\6\0\1\233\4\0\1\213"+
    "\14\0\1\215\1\0\1\216\7\0\10\233\1\234\22\233"+
    "\15\0\1\217\6\0\1\220\5\0\1\233\15\0\1\217"+
    "\6\0\1\220\6\0\10\233\1\234\2\233\2\237\16\233"+
    "\4\0\1\221\3\0\1\224\14\0\1\225\4\0\1\233"+
    "\2\0\1\241\1\0\1\221\3\0\1\251\2\0\1\241"+
    "\11\0\1\252\1\0\1\241\3\0\1\253\7\233\1\234"+
    "\22\233\26\0\1\226\3\0\1\233\26\0\1\226\4\0"+
    "\10\233\1\234\2\233\2\237\16\233\27\0\1\230\2\0"+
    "\1\233\2\0\1\241\5\0\1\241\2\0\1\241\11\0"+
    "\1\241\1\0\1\254\3\0\10\233\1\234\22\233\30\0"+
    "\1\231\1\0\1\233\30\0\1\231\2\0\10\233\1\234"+
    "\22\233\31\0\1\232\1\233\31\0\1\232\1\0\3\233"+
    "\40\0\1\166\32\0\1\166\22\0\1\166\36\0\1\247"+
    "\15\0\1\212\14\0\1\247\15\0\1\212\11\0\1\212"+
    "\32\0\1\255\32\0\1\255\46\0\12\5\36\0\2\256"+
    "\15\0\1\256\31\0\12\5\36\0\2\257\15\0\1\257"+
    "\31\0\12\5\36\0\2\260\15\0\1\260\31\0\12\5"+
    "\36\0\2\261\15\0\1\261\31\0\12\5\36\0\2\262"+
    "\15\0\1\262\31\0\12\5\36\0\2\263\15\0\1\263"+
    "\31\0\12\5\36\0\2\264\15\0\1\264\31\0\12\5"+
    "\36\0\2\265\15\0\1\265\31\0\12\5\36\0\2\266"+
    "\15\0\1\266\31\0\12\5\36\0\2\267\15\0\1\267"+
    "\31\0\12\5\36\0\2\270\15\0\1\270\31\0\12\5"+
    "\36\0\2\271\15\0\1\271\31\0\12\5\36\0\2\272"+
    "\15\0\1\272\31\0\12\5\36\0\2\273\15\0\1\273"+
    "\31\0\12\5\36\0\2\274\15\0\1\274\31\0\12\5"+
    "\36\0\2\275\15\0\1\275\43\0\1\276\74\0\5\233"+
    "\1\234\22\233\1\143\31\0\1\233\1\143\32\0\10\233"+
    "\1\234\22\233\32\0\1\233\33\0\10\233\1\234\22\233"+
    "\13\0\1\277\16\0\1\233\13\0\1\277\17\0\10\233"+
    "\1\234\22\233\23\0\1\300\6\0\1\233\23\0\1\300"+
    "\7\0\10\233\1\234\22\233\1\0\1\143\30\0\1\233"+
    "\1\0\1\143\31\0\10\233\1\234\22\233\22\0\1\301"+
    "\7\0\1\233\22\0\1\301\10\0\1\233\1\301\1\233"+
    "\47\0\1\302\32\0\1\302\16\0\5\233\1\234\22\233"+
    "\2\0\1\303\5\0\1\152\2\0\1\152\11\0\1\152"+
    "\1\0\1\152\2\0\1\233\2\0\1\143\30\0\3\233"+
    "\32\0\1\152\5\0\1\152\2\0\1\152\11\0\1\152"+
    "\1\0\1\152\41\0\5\233\1\234\22\233\2\0\1\143"+
    "\27\0\1\233\2\0\1\143\30\0\10\233\1\234\22\233"+
    "\3\0\1\143\26\0\1\233\3\0\1\143\27\0\3\233"+
    "\32\0\1\304\32\0\1\304\65\0\1\305\32\0\1\305"+
    "\66\0\1\306\32\0\1\306\100\0\1\307\32\0\1\307"+
    "\17\0\5\233\1\234\22\233\4\0\1\143\25\0\1\233"+
    "\4\0\1\143\26\0\10\233\1\234\22\233\5\0\1\143"+
    "\24\0\1\233\5\0\1\143\25\0\10\233\1\234\22\233"+
    "\6\0\1\143\23\0\1\233\6\0\1\143\24\0\10\233"+
    "\1\234\22\233\7\0\1\143\22\0\1\233\7\0\1\143"+
    "\23\0\10\233\1\234\22\233\2\0\1\152\5\0\1\303"+
    "\2\0\1\152\11\0\1\152\1\0\1\152\2\0\1\233"+
    "\10\0\1\143\22\0\1\235\7\233\1\234\22\233\10\0"+
    "\1\143\21\0\1\233\10\0\1\143\22\0\1\235\7\233"+
    "\1\234\22\233\11\0\1\143\20\0\1\233\11\0\1\143"+
    "\21\0\10\233\1\234\22\233\12\0\1\143\17\0\1\233"+
    "\12\0\1\143\20\0\2\233\1\235\31\0\1\310\1\152"+
    "\5\0\1\152\2\0\1\152\11\0\1\152\1\0\1\152"+
    "\4\0\1\310\34\0\5\233\1\234\22\233\2\0\1\152"+
    "\5\0\1\152\2\0\1\303\11\0\1\152\1\0\1\152"+
    "\2\0\1\233\13\0\1\143\17\0\3\233\31\0\1\310"+
    "\32\0\1\310\34\0\5\233\1\234\22\233\13\0\1\143"+
    "\16\0\1\233\13\0\1\143\17\0\10\233\1\234\22\233"+
    "\14\0\1\143\15\0\1\233\14\0\1\143\16\0\10\233"+
    "\1\234\22\233\15\0\1\143\14\0\1\233\15\0\1\143"+
    "\15\0\3\233\45\0\1\311\7\0\1\312\22\0\1\311"+
    "\7\0\1\312\63\0\1\313\32\0\1\313\12\0\5\233"+
    "\1\234\22\233\16\0\1\143\13\0\1\233\16\0\1\143"+
    "\14\0\3\233\53\0\1\314\32\0\1\314\63\0\1\315"+
    "\32\0\1\315\14\0\5\233\1\234\22\233\17\0\1\143"+
    "\12\0\1\233\17\0\1\143\13\0\3\233\40\0\1\316"+
    "\32\0\1\316\22\0\1\316\2\0\5\233\1\234\22\233"+
    "\20\0\1\143\11\0\1\233\20\0\1\143\12\0\3\233"+
    "\30\0\1\317\7\0\1\320\22\0\1\317\7\0\1\320"+
    "\22\0\1\320\2\0\5\233\1\234\22\233\21\0\1\143"+
    "\10\0\1\233\21\0\1\143\11\0\3\233\32\0\1\321"+
    "\1\322\4\0\1\323\3\0\1\324\2\0\1\325\2\0"+
    "\1\326\1\327\3\0\1\330\1\0\1\331\3\0\1\321"+
    "\1\322\4\0\1\323\3\0\1\324\2\0\1\325\2\0"+
    "\1\326\1\327\3\0\1\330\1\0\1\331\1\0\1\323"+
    "\1\326\1\0\5\233\1\234\22\233\22\0\1\143\7\0"+
    "\1\233\22\0\1\143\10\0\1\233\1\235\1\233\51\0"+
    "\1\332\32\0\1\332\67\0\1\333\32\0\1\333\46\0"+
    "\1\334\32\0\1\334\31\0\5\233\1\234\22\233\23\0"+
    "\1\143\6\0\1\233\23\0\1\143\7\0\3\233\33\0"+
    "\1\335\21\0\1\336\10\0\1\335\21\0\1\336\10\0"+
    "\5\233\1\234\22\233\24\0\1\143\5\0\1\233\24\0"+
    "\1\143\6\0\3\233\45\0\1\337\32\0\1\337\52\0"+
    "\1\340\5\0\1\152\2\0\1\152\11\0\1\152\1\0"+
    "\1\152\5\0\1\341\33\0\5\233\1\234\22\233\2\0"+
    "\1\152\5\0\1\152\2\0\1\152\11\0\1\303\1\0"+
    "\1\152\2\0\1\233\25\0\1\143\5\0\3\233\32\0"+
    "\1\341\32\0\1\341\33\0\5\233\1\234\22\233\25\0"+
    "\1\143\4\0\1\233\25\0\1\143\5\0\10\233\1\234"+
    "\22\233\26\0\1\143\3\0\1\233\26\0\1\143\4\0"+
    "\10\233\1\234\22\233\2\0\1\152\5\0\1\152\2\0"+
    "\1\152\11\0\1\152\1\0\1\303\2\0\1\233\27\0"+
    "\1\143\3\0\10\233\1\234\22\233\27\0\1\143\2\0"+
    "\1\233\27\0\1\143\3\0\10\233\1\234\22\233\30\0"+
    "\1\143\1\0\1\233\30\0\1\143\2\0\10\233\1\234"+
    "\22\233\31\0\1\143\1\233\31\0\1\143\1\0\3\233"+
    "\2\0\1\342\116\0\5\233\1\234\2\233\2\237\16\233"+
    "\2\0\1\143\27\0\1\233\2\0\1\343\5\0\1\241"+
    "\2\0\1\241\11\0\1\241\1\0\1\241\3\0\3\233"+
    "\10\0\2\237\53\0\1\241\5\0\1\241\2\0\1\241"+
    "\11\0\1\241\1\0\1\241\6\0\5\233\1\234\2\233"+
    "\2\237\16\233\10\0\1\143\21\0\1\233\2\0\1\241"+
    "\5\0\1\343\2\0\1\241\11\0\1\241\1\0\1\241"+
    "\3\0\1\235\7\233\1\234\2\233\2\237\16\233\13\0"+
    "\1\143\16\0\1\233\2\0\1\241\5\0\1\241\2\0"+
    "\1\343\11\0\1\241\1\0\1\241\3\0\3\233\32\0"+
    "\1\321\1\322\4\0\1\323\3\0\1\324\2\0\1\325"+
    "\2\0\1\326\1\327\3\0\1\330\5\0\1\321\1\322"+
    "\4\0\1\323\3\0\1\324\2\0\1\325\2\0\1\326"+
    "\1\327\3\0\1\330\3\0\1\323\1\326\11\0\2\237"+
    "\20\0\1\341\32\0\1\344\5\0\1\241\2\0\1\241"+
    "\11\0\1\241\1\0\1\241\6\0\5\233\1\234\2\233"+
    "\2\237\16\233\25\0\1\143\4\0\1\233\2\0\1\241"+
    "\5\0\1\241\2\0\1\241\11\0\1\343\1\0\1\241"+
    "\3\0\10\233\1\234\2\233\2\237\16\233\27\0\1\143"+
    "\2\0\1\233\2\0\1\241\5\0\1\241\2\0\1\241"+
    "\11\0\1\241\1\0\1\343\3\0\3\233\52\0\1\345"+
    "\32\0\1\345\11\0\1\345\50\0\1\346\32\0\1\346"+
    "\27\0\1\347\22\0\1\350\32\0\1\350\37\0\1\351"+
    "\2\0\1\351\26\0\1\352\32\0\1\352\22\0\1\352"+
    "\3\0\1\353\2\0\1\353\1\0\1\353\1\354\45\0"+
    "\1\355\32\0\1\355\50\0\1\214\5\0\1\347\24\0"+
    "\1\214\5\0\1\347\14\0\1\214\2\0\5\233\1\234"+
    "\22\233\2\0\1\152\5\0\1\152\2\0\1\152\11\0"+
    "\1\152\1\0\1\152\2\0\1\233\33\0\3\233\40\0"+
    "\1\356\32\0\1\356\22\0\1\356\42\0\1\357\32\0"+
    "\1\357\22\0\1\357\42\0\1\360\32\0\1\360\22\0"+
    "\1\360\35\0\1\361\21\0\1\355\10\0\1\361\21\0"+
    "\1\355\61\0\1\362\32\0\1\362\14\0\2\140\4\0"+
    "\32\140\1\363\32\140\1\363\22\140\1\363\2\140\40\0"+
    "\1\364\5\0\1\365\24\0\1\364\5\0\1\365\14\0"+
    "\1\364\42\0\1\366\5\0\1\367\24\0\1\366\5\0"+
    "\1\367\14\0\1\366\32\0\1\370\32\0\1\370\110\0"+
    "\1\371\32\0\1\371\56\0\1\372\32\0\1\372\72\0"+
    "\1\373\1\0\1\374\30\0\1\373\1\0\1\374\57\0"+
    "\1\375\32\0\1\375\66\0\1\376\32\0\1\376\53\0"+
    "\1\377\3\0\1\u0100\26\0\1\377\3\0\1\u0100\22\0"+
    "\1\u0100\36\0\1\u0101\32\0\1\u0101\65\0\1\u0102\32\0"+
    "\1\u0102\104\0\1\u0103\32\0\1\u0103\65\0\1\u0104\32\0"+
    "\1\u0104\65\0\1\u0105\32\0\1\u0105\45\0\1\u0106\4\0"+
    "\1\u0107\25\0\1\u0106\4\0\1\u0107\22\0\1\u0107\42\0"+
    "\1\u0108\32\0\1\u0108\22\0\1\u0108\3\0\1\u0109\2\0"+
    "\1\u0109\1\0\1\u0109\1\u010a\23\0\1\u010b\21\0\1\u010c"+
    "\3\0\1\u010d\4\0\1\u010b\21\0\1\u010c\3\0\1\u010d"+
    "\52\0\1\u010e\32\0\1\u010e\52\0\1\u010f\32\0\1\u010f"+
    "\66\0\1\u0110\3\0\1\u0111\26\0\1\u0110\3\0\1\u0111"+
    "\22\0\1\u0111\42\0\1\u0112\32\0\1\u0112\22\0\1\u0112"+
    "\55\0\1\u0113\32\0\1\u0113\44\0\1\152\5\0\1\u0114"+
    "\2\0\1\152\11\0\1\152\1\0\1\152\13\0\1\u0115"+
    "\22\0\1\u0115\42\0\1\u0115\32\0\1\u0115\22\0\1\u0115"+
    "\2\0\5\233\1\234\2\233\2\237\16\233\32\0\1\233"+
    "\2\0\1\241\5\0\1\241\2\0\1\241\11\0\1\241"+
    "\1\0\1\241\3\0\3\233\10\0\2\237\26\0\1\u0115"+
    "\24\0\1\241\5\0\1\u0116\2\0\1\241\11\0\1\241"+
    "\1\0\1\241\3\0\1\u0115\51\0\1\u0117\32\0\1\u0117"+
    "\17\0\1\u0118\2\0\1\u0118\1\0\1\u0118\1\u0119\17\0"+
    "\1\u011a\127\0\1\u011b\32\0\1\u011b\30\0\1\u011c\2\0"+
    "\1\u011c\1\0\1\u011c\1\u011d\44\0\1\u011e\32\0\1\u011e"+
    "\43\0\1\u011f\32\0\1\u011f\100\0\1\u0120\32\0\1\u0120"+
    "\60\0\1\u0121\32\0\1\u0121\22\0\1\u0121\36\0\1\u0122"+
    "\7\0\1\u0123\22\0\1\u0122\7\0\1\u0123\51\0\1\u0124"+
    "\15\0\1\u0125\14\0\1\u0124\15\0\1\u0125\51\0\1\u0126"+
    "\32\0\1\u0126\67\0\1\u0127\32\0\1\u0127\77\0\1\347"+
    "\32\0\1\347\53\0\1\u0128\32\0\1\u0128\65\0\1\u0129"+
    "\32\0\1\u0129\64\0\1\u012a\32\0\1\u012a\66\0\1\u012b"+
    "\32\0\1\u012b\64\0\1\u012c\32\0\1\u012c\107\0\1\u012d"+
    "\32\0\1\u012d\44\0\1\347\32\0\1\347\31\0\2\122"+
    "\4\0\113\122\53\0\1\u012e\32\0\1\u012e\46\0\1\u012f"+
    "\16\0\1\u0130\13\0\1\u012f\16\0\1\u0130\45\0\1\u0131"+
    "\14\0\1\u0132\2\0\1\u0133\1\0\1\u0134\10\0\1\u0131"+
    "\14\0\1\u0132\2\0\1\u0133\1\0\1\u0134\55\0\1\u0135"+
    "\32\0\1\u0135\52\0\1\u0136\32\0\1\u0136\65\0\1\u0137"+
    "\32\0\1\u0137\105\0\1\u0138\32\0\1\u0138\11\0\1\u0138"+
    "\44\0\1\u0139\32\0\1\u0139\55\0\1\u013a\4\0\1\u013b"+
    "\25\0\1\u013a\4\0\1\u013b\22\0\1\u013b\2\0\2\135"+
    "\4\0\113\135\40\0\1\u013c\32\0\1\u013c\22\0\1\u013c"+
    "\36\0\1\377\32\0\1\377\65\0\1\u013d\32\0\1\u013d"+
    "\77\0\1\u013e\32\0\1\u013e\20\0\1\u0109\2\0\1\u0109"+
    "\1\0\1\u0109\1\u010a\23\0\1\u010b\21\0\1\u010c\10\0"+
    "\1\u010b\21\0\1\u010c\55\0\1\u013f\32\0\1\u013f\54\0"+
    "\1\u0140\32\0\1\u0140\71\0\1\u0141\32\0\1\u0141\22\0"+
    "\1\u0141\2\0\2\132\4\0\113\132\43\0\1\362\32\0"+
    "\1\362\62\0\1\u0142\32\0\1\u0142\22\0\1\u0142\34\0"+
    "\1\u0143\22\0\1\u0144\7\0\1\u0143\22\0\1\u0144\42\0"+
    "\1\u0145\32\0\1\u0145\65\0\1\u0146\32\0\1\u0146\67\0"+
    "\1\u0147\3\0\1\u0148\13\0\1\u0149\12\0\1\u0147\3\0"+
    "\1\u0148\13\0\1\u0149\6\0\1\u0148\34\0\1\152\1\0"+
    "\1\u014a\3\0\1\152\2\0\1\152\11\0\1\152\1\0"+
    "\1\152\7\0\1\u014a\65\0\1\u014a\32\0\1\u014a\41\0"+
    "\2\237\22\0\1\u014a\30\0\1\241\1\0\1\u014a\3\0"+
    "\1\241\2\0\1\241\11\0\1\241\1\0\1\241\33\0"+
    "\1\3\73\0\27\u0118\1\u011a\71\u0118\45\0\1\u014b\32\0"+
    "\1\u014b\50\0\1\u014c\32\0\1\u014c\102\0\1\u014d\32\0"+
    "\1\u014d\65\0\1\u014e\32\0\1\u014e\66\0\1\u014f\32\0"+
    "\1\u014f\50\0\1\u0150\32\0\1\u0150\66\0\1\u0151\32\0"+
    "\1\u0151\100\0\1\u0152\4\0\1\u0153\25\0\1\u0152\4\0"+
    "\1\u0153\11\0\1\u0153\1\0\2\256\4\0\113\256\45\0"+
    "\1\u0154\4\0\1\u0155\25\0\1\u0154\4\0\1\u0155\11\0"+
    "\1\u0155\54\0\1\u0156\32\0\1\u0156\46\0\1\u0157\32\0"+
    "\1\u0157\63\0\1\u0158\22\0\1\u0159\7\0\1\u0158\22\0"+
    "\1\u0159\62\0\1\u015a\32\0\1\u015a\11\0\1\u015a\46\0"+
    "\1\u0128\4\0\1\u015b\25\0\1\u0128\4\0\1\u015b\11\0"+
    "\1\u015b\35\0\1\u015c\32\0\1\u015c\76\0\1\u015d\4\0"+
    "\1\u015e\25\0\1\u015d\4\0\1\u015e\11\0\1\u015e\35\0"+
    "\1\u015f\32\0\1\u015f\31\0\2\137\4\0\113\137\2\133"+
    "\4\0\26\133\1\u0160\32\133\1\u0160\31\133\51\0\1\u0161"+
    "\32\0\1\u0161\62\0\1\u0162\32\0\1\u0162\53\0\1\u0163"+
    "\3\0\1\u0164\26\0\1\u0163\3\0\1\u0164\22\0\1\u0164"+
    "\56\0\1\u0165\32\0\1\u0165\11\0\2\134\4\0\113\134"+
    "\40\0\1\u0166\32\0\1\u0166\22\0\1\u0166\35\0\1\u0167"+
    "\32\0\1\u0167\72\0\1\u0168\32\0\1\u0168\22\0\1\u0168"+
    "\36\0\1\u0169\32\0\1\u0169\32\0\1\u0138\2\0\1\u0138"+
    "\1\0\1\u0138\1\u016a\23\0\1\u0106\32\0\1\u0106\33\0"+
    "\1\u016b\2\0\1\u016b\1\0\1\u016b\1\u016c\45\0\1\336"+
    "\32\0\1\336\44\0\1\u016d\32\0\1\u016d\65\0\1\u016e"+
    "\32\0\1\u016e\75\0\1\u016f\32\0\1\u016f\66\0\1\u0170"+
    "\4\0\1\u0171\25\0\1\u0170\4\0\1\u0171\11\0\1\u0171"+
    "\46\0\1\371\32\0\1\371\51\0\1\u0172\32\0\1\u0172"+
    "\66\0\1\u0173\32\0\1\u0173\65\0\1\u0174\32\0\1\u0174"+
    "\65\0\1\u0175\32\0\1\u0175\73\0\1\u0176\32\0\1\u0176"+
    "\22\0\1\u0176\42\0\1\u015c\32\0\1\u015c\22\0\1\u015c"+
    "\36\0\1\u0177\32\0\1\u0177\71\0\1\u0178\32\0\1\u0178"+
    "\22\0\1\u0178\54\0\1\u0179\32\0\1\u0179\11\0\1\u0179"+
    "\33\0\1\u017a\1\u017b\14\0\1\u017c\2\0\1\u017d\11\0"+
    "\1\u017a\1\u017b\14\0\1\u017c\2\0\1\u017d\57\0\1\u017e"+
    "\32\0\1\u017e\65\0\1\u017f\4\0\1\u0180\25\0\1\u017f"+
    "\4\0\1\u0180\11\0\1\u0180\32\0\1\u0181\32\0\1\u0181"+
    "\107\0\1\u0182\32\0\1\u0182\43\0\1\u0183\32\0\1\u0183"+
    "\74\0\1\u0184\32\0\1\u0184\22\0\1\u0184\45\0\1\u0185"+
    "\32\0\1\u0185\74\0\1\u0186\32\0\1\u0186\11\0\1\u0186"+
    "\41\0\1\u0187\32\0\1\u0187\22\0\1\u0187\54\0\1\u0153"+
    "\32\0\1\u0153\11\0\1\u0153\46\0\1\u0188\32\0\1\u0188"+
    "\72\0\1\u0189\32\0\1\u0189\11\0\1\u0189\54\0\1\u018a"+
    "\32\0\1\u018a\64\0\1\u018b\32\0\1\u018b\11\0\1\u018b"+
    "\41\0\1\u018c\32\0\1\u018c\22\0\1\u018c\42\0\1\u015f"+
    "\32\0\1\u015f\22\0\1\u015f\3\0\1\u018d\2\0\1\u018d"+
    "\1\0\1\u018d\1\u018e\23\0\1\u012a\32\0\1\u012a\64\0"+
    "\1\u018f\32\0\1\u018f\105\0\1\u0190\32\0\1\u0190\11\0"+
    "\1\u0190\2\0\1\u0191\2\0\1\u0191\1\0\1\u0191\1\u0192"+
    "\23\0\1\u012c\32\0\1\u012c\64\0\1\u0193\32\0\1\u0193"+
    "\104\0\1\u0194\32\0\1\u0194\15\0\1\u0195\2\0\1\u0195"+
    "\1\0\1\u0195\1\u0196\23\0\1\u0197\21\0\1\u0198\10\0"+
    "\1\u0197\21\0\1\u0198\61\0\1\u0199\32\0\1\u0199\46\0"+
    "\1\u019a\32\0\1\u019a\65\0\1\u019b\32\0\1\u019b\73\0"+
    "\1\u019c\32\0\1\u019c\22\0\1\u019c\34\0\1\u019d\32\0"+
    "\1\u019d\33\0\2\131\4\0\113\131\34\0\1\u019e\32\0"+
    "\1\u019e\103\0\1\u019f\32\0\1\u019f\11\0\1\u019f\46\0"+
    "\1\u01a0\32\0\1\u01a0\65\0\1\u01a1\32\0\1\u01a1\52\0"+
    "\1\u01a2\32\0\1\u01a2\100\0\1\u01a3\4\0\1\u01a4\25\0"+
    "\1\u01a3\4\0\1\u01a4\11\0\1\u01a4\1\0\2\136\4\0"+
    "\113\136\52\0\1\u01a5\32\0\1\u01a5\11\0\1\u01a5\53\0"+
    "\1\u01a6\32\0\1\u01a6\11\0\1\u01a6\41\0\1\u01a7\32\0"+
    "\1\u01a7\22\0\1\u01a7\42\0\1\u01a8\32\0\1\u01a8\22\0"+
    "\1\u01a8\36\0\1\u01a9\32\0\1\u01a9\65\0\1\u01aa\32\0"+
    "\1\u01aa\103\0\1\u01ab\32\0\1\u01ab\11\0\1\u01ab\35\0"+
    "\1\u01ac\32\0\1\u01ac\71\0\1\u01ad\32\0\1\u01ad\22\0"+
    "\1\u01ad\42\0\1\u01ae\32\0\1\u01ae\22\0\1\u01ae\56\0"+
    "\1\u01af\32\0\1\u01af\65\0\1\u01b0\32\0\1\u01b0\62\0"+
    "\1\u01b1\32\0\1\u01b1\50\0\1\u01b2\32\0\1\u01b2\103\0"+
    "\1\u0180\32\0\1\u0180\11\0\1\u0180\2\0\1\u01b3\2\0"+
    "\1\u01b3\1\0\1\u01b3\1\u01b4\21\0\1\u01b5\16\0\1\u01b6"+
    "\1\0\1\u01b7\1\u01b8\10\0\1\u01b5\16\0\1\u01b6\1\0"+
    "\1\u01b7\1\u01b8\10\0\1\u01b7\53\0\1\u01b9\32\0\1\u01b9"+
    "\11\0\1\u01b9\41\0\1\347\5\0\1\347\24\0\1\347"+
    "\5\0\1\347\14\0\1\347\54\0\1\u01ba\32\0\1\u01ba"+
    "\11\0\1\u01ba\33\0\1\u01bb\32\0\1\u01bb\101\0\1\351"+
    "\32\0\1\351\66\0\1\u01bc\32\0\1\u01bc\52\0\1\u01bd"+
    "\32\0\1\u01bd\77\0\1\u01be\32\0\1\u01be\53\0\1\u01bf"+
    "\32\0\1\u01bf\65\0\1\u01c0\32\0\1\u01c0\71\0\1\u01c1"+
    "\32\0\1\u01c1\22\0\1\u01c1\36\0\1\u01c2\32\0\1\u01c2"+
    "\76\0\1\u01c3\32\0\1\u01c3\60\0\1\u01c4\32\0\1\u01c4"+
    "\22\0\1\u01c4\47\0\1\u01c5\32\0\1\u01c5\60\0\1\u01c6"+
    "\32\0\1\u01c6\22\0\1\u01c6\47\0\1\u01c7\32\0\1\u01c7"+
    "\54\0\1\u01c8\32\0\1\u01c8\71\0\1\u01c9\32\0\1\u01c9"+
    "\22\0\1\u01c9\35\0\1\u01ca\32\0\1\u01ca\72\0\1\u01cb"+
    "\32\0\1\u01cb\22\0\1\u01cb\36\0\1\u01cc\32\0\1\u01cc"+
    "\65\0\1\u01cd\32\0\1\u01cd\71\0\1\u01ce\32\0\1\u01ce"+
    "\22\0\1\u01ce\47\0\1\u01cf\4\0\1\u01d0\25\0\1\u01cf"+
    "\4\0\1\u01d0\11\0\1\u01d0\41\0\1\u01d1\32\0\1\u01d1"+
    "\22\0\1\u01d1\33\0\1\u01d2\32\0\1\u01d2\65\0\1\u01d3"+
    "\32\0\1\u01d3\74\0\1\u01d4\32\0\1\u01d4\22\0\1\u01d4"+
    "\54\0\1\u01d5\32\0\1\u01d5\11\0\1\u01d5\2\0\1\u01d6"+
    "\2\0\1\u01d6\1\0\1\u01d6\1\u01d7\23\0\1\u013a\32\0"+
    "\1\u013a\101\0\1\u01d8\32\0\1\u01d8\52\0\1\u01d9\32\0"+
    "\1\u01d9\65\0\1\u01da\32\0\1\u01da\103\0\1\u01db\32\0"+
    "\1\u01db\11\0\1\u01db\46\0\1\u01dc\4\0\1\u01dd\25\0"+
    "\1\u01dc\4\0\1\u01dd\11\0\1\u01dd\41\0\1\u01de\32\0"+
    "\1\u01de\22\0\1\u01de\47\0\1\u01df\4\0\1\u01e0\25\0"+
    "\1\u01df\4\0\1\u01e0\11\0\1\u01e0\45\0\1\u01e1\32\0"+
    "\1\u01e1\66\0\1\u01e2\32\0\1\u01e2\54\0\1\u01e3\32\0"+
    "\1\u01e3\61\0\1\u01e4\32\0\1\u01e4\71\0\1\u01e5\32\0"+
    "\1\u01e5\103\0\1\u01e6\32\0\1\u01e6\11\0\1\u01e6\46\0"+
    "\1\u01e7\32\0\1\u01e7\60\0\1\u01e8\32\0\1\u01e8\22\0"+
    "\1\u01e8\56\0\1\u01e9\32\0\1\u01e9\45\0\1\u01ea\32\0"+
    "\1\u01ea\65\0\1\u01eb\32\0\1\u01eb\100\0\1\u01ec\32\0"+
    "\1\u01ec\65\0\1\u01ed\32\0\1\u01ed\64\0\1\u01ee\32\0"+
    "\1\u01ee\44\0\1\353\140\0\1\u01e8\4\0\1\u01ef\25\0"+
    "\1\u01e8\4\0\1\u01ef\11\0\1\u01ef\56\0\1\u01f0\32\0"+
    "\1\u01f0\63\0\1\u01f1\32\0\1\u01f1\64\0\1\u01f2\32\0"+
    "\1\u01f2\11\0\1\u01f2\45\0\1\u01f3\32\0\1\u01f3\66\0"+
    "\1\u01f4\4\0\1\u01f5\25\0\1\u01f4\4\0\1\u01f5\11\0"+
    "\1\u01f5\32\0\1\u01f6\32\0\1\u01f6\70\0\1\u01f7\32\0"+
    "\1\u01f7\62\0\1\u01f8\32\0\1\u01f8\70\0\1\u01f9\32\0"+
    "\1\u01f9\62\0\1\u01fa\32\0\1\u01fa\66\0\1\u01fb\32\0"+
    "\1\u01fb\65\0\1\u01fc\32\0\1\u01fc\73\0\1\u01fd\32\0"+
    "\1\u01fd\22\0\1\u01fd\36\0\1\u01fe\32\0\1\u01fe\103\0"+
    "\1\u01ff\32\0\1\u01ff\11\0\1\u01ff\46\0\1\u0200\4\0"+
    "\1\u0201\25\0\1\u0200\4\0\1\u0201\11\0\1\u0201\35\0"+
    "\1\u0202\32\0\1\u0202\103\0\1\u01d0\32\0\1\u01d0\11\0"+
    "\1\u01d0\45\0\1\u0203\32\0\1\u0203\73\0\1\u0204\32\0"+
    "\1\u0204\11\0\1\u0204\53\0\1\u0205\32\0\1\u0205\11\0"+
    "\1\u0205\35\0\1\u0206\32\0\1\u0206\76\0\1\u0207\32\0"+
    "\1\u0207\45\0\1\u0109\140\0\1\u0208\4\0\1\u0209\25\0"+
    "\1\u0208\4\0\1\u0209\11\0\1\u0209\46\0\1\u020a\4\0"+
    "\1\u020b\25\0\1\u020a\4\0\1\u020b\11\0\1\u020b\41\0"+
    "\1\u020c\32\0\1\u020c\22\0\1\u020c\54\0\1\u01dd\32\0"+
    "\1\u01dd\11\0\1\u01dd\45\0\1\u020d\32\0\1\u020d\73\0"+
    "\1\u01e0\32\0\1\u01e0\11\0\1\u01e0\1\0\2\270\4\0"+
    "\113\270\50\0\1\u020e\32\0\1\u020e\67\0\1\u020f\32\0"+
    "\1\u020f\11\0\1\u020f\54\0\1\u0210\32\0\1\u0210\46\0"+
    "\1\u0211\32\0\1\u0211\71\0\1\u0212\32\0\1\u0212\22\0"+
    "\1\u0212\33\0\1\u0213\32\0\1\u0213\106\0\1\u01ef\32\0"+
    "\1\u01ef\11\0\1\u01ef\31\0\1\u0214\7\0\1\u0215\22\0"+
    "\1\u0214\7\0\1\u0215\22\0\1\u0215\46\0\1\u0216\32\0"+
    "\1\u0216\72\0\1\u020b\32\0\1\u020b\41\0\1\u0118\120\0"+
    "\1\u011c\127\0\1\u0217\32\0\1\u0217\104\0\1\u0218\32\0"+
    "\1\u0218\52\0\1\u0219\32\0\1\u0219\22\0\1\u0219\2\0"+
    "\2\260\4\0\113\260\52\0\1\u01f5\32\0\1\u01f5\11\0"+
    "\1\u01f5\53\0\1\u021a\32\0\1\u021a\11\0\1\u021a\46\0"+
    "\1\u021b\4\0\1\u021c\25\0\1\u021b\4\0\1\u021c\11\0"+
    "\1\u021c\53\0\1\u021d\32\0\1\u021d\11\0\1\u021d\46\0"+
    "\1\u021e\4\0\1\u021f\25\0\1\u021e\4\0\1\u021f\11\0"+
    "\1\u021f\53\0\1\u0220\32\0\1\u0220\11\0\1\u0220\41\0"+
    "\1\u0221\32\0\1\u0221\22\0\1\u0221\42\0\1\u0222\32\0"+
    "\1\u0222\22\0\1\u0222\34\0\1\u0223\32\0\1\u0223\100\0"+
    "\1\u0224\4\0\1\u0225\25\0\1\u0224\4\0\1\u0225\11\0"+
    "\1\u0225\41\0\1\u0226\32\0\1\u0226\22\0\1\u0226\54\0"+
    "\1\u0227\32\0\1\u0227\11\0\1\u0227\2\0\1\u0228\2\0"+
    "\1\u0228\1\0\1\u0228\1\u0229\23\0\1\u022a\21\0\1\u0134"+
    "\10\0\1\u022a\21\0\1\u0134\55\0\1\u022b\4\0\1\u022c"+
    "\25\0\1\u022b\4\0\1\u022c\11\0\1\u022c\1\0\2\264"+
    "\4\0\113\264\47\0\1\u022d\32\0\1\u022d\65\0\1\u022e"+
    "\32\0\1\u022e\63\0\1\u022f\4\0\1\u0230\25\0\1\u022f"+
    "\4\0\1\u0230\11\0\1\u0230\32\0\1\u0231\32\0\1\u0231"+
    "\106\0\1\u0209\32\0\1\u0209\11\0\1\u0209\53\0\1\u020b"+
    "\32\0\1\u020b\11\0\1\u020b\45\0\1\u0232\32\0\1\u0232"+
    "\21\0\2\257\4\0\113\257\54\0\1\u0233\32\0\1\u0233"+
    "\51\0\1\u0234\32\0\1\u0234\22\0\1\u0234\55\0\1\u0235"+
    "\32\0\1\u0235\64\0\1\u0236\32\0\1\u0236\11\0\1\u0236"+
    "\45\0\1\u0237\32\0\1\u0237\73\0\1\u0238\32\0\1\u0238"+
    "\11\0\1\u0238\54\0\1\u0239\32\0\1\u0239\57\0\1\u023a"+
    "\32\0\1\u023a\54\0\1\u023b\32\0\1\u023b\103\0\1\u023c"+
    "\32\0\1\u023c\11\0\1\u023c\35\0\1\u023d\32\0\1\u023d"+
    "\75\0\1\u023e\32\0\1\u023e\70\0\1\u023f\32\0\1\u023f"+
    "\70\0\1\u021c\32\0\1\u021c\11\0\1\u021c\50\0\1\u0240"+
    "\32\0\1\u0240\70\0\1\u021f\32\0\1\u021f\11\0\1\u021f"+
    "\50\0\1\u0241\32\0\1\u0241\52\0\1\u0242\32\0\1\u0242"+
    "\65\0\1\u0243\32\0\1\u0243\65\0\1\u0244\32\0\1\u0244"+
    "\103\0\1\u0225\32\0\1\u0225\11\0\1\u0225\45\0\1\u0245"+
    "\32\0\1\u0245\22\0\1\u0246\2\0\1\u0246\1\0\1\u0246"+
    "\1\u0247\45\0\1\u0134\32\0\1\u0134\55\0\1\u0248\32\0"+
    "\1\u0248\54\0\1\u0163\32\0\1\u0163\103\0\1\u022c\32\0"+
    "\1\u022c\11\0\1\u022c\26\0\1\u0138\120\0\1\u016b\145\0"+
    "\1\u0230\32\0\1\u0230\11\0\1\u0230\53\0\1\u0249\32\0"+
    "\1\u0249\11\0\1\u0249\1\0\2\261\4\0\113\261\34\0"+
    "\1\u024a\32\0\1\u024a\75\0\1\u024b\32\0\1\u024b\72\0"+
    "\1\u024c\32\0\1\u024c\54\0\1\u024d\32\0\1\u024d\22\0"+
    "\1\u024d\2\0\2\271\4\0\113\271\47\0\1\u024e\32\0"+
    "\1\u024e\52\0\1\u024f\32\0\1\u024f\101\0\1\u0250\32\0"+
    "\1\u0250\60\0\1\u01e0\32\0\1\u01e0\62\0\1\u0251\32\0"+
    "\1\u0251\22\0\1\u0251\54\0\1\u0252\32\0\1\u0252\11\0"+
    "\1\u0252\1\0\2\266\4\0\113\266\25\0\1\u018d\120\0"+
    "\1\u0191\120\0\1\u0195\140\0\1\u0253\4\0\1\u0254\25\0"+
    "\1\u0253\4\0\1\u0254\11\0\1\u0254\46\0\1\u0255\4\0"+
    "\1\u0256\25\0\1\u0255\4\0\1\u0256\11\0\1\u0256\53\0"+
    "\1\u0257\32\0\1\u0257\11\0\1\u0257\1\0\2\263\4\0"+
    "\113\263\45\0\1\u0258\32\0\1\u0258\51\0\1\u0259\32\0"+
    "\1\u0259\103\0\1\u025a\32\0\1\u025a\70\0\1\u025b\32\0"+
    "\1\u025b\11\0\1\u025b\1\0\2\272\4\0\113\272\34\0"+
    "\1\u025c\32\0\1\u025c\75\0\1\u025d\32\0\1\u025d\46\0"+
    "\1\u01b3\144\0\1\u0256\32\0\1\u0256\70\0\1\u019d\32\0"+
    "\1\u019d\55\0\1\u025e\32\0\1\u025e\61\0\1\u025f\32\0"+
    "\1\u025f\22\0\1\u025f\54\0\1\u0254\32\0\1\u0254\11\0"+
    "\1\u0254\53\0\1\u0256\32\0\1\u0256\11\0\1\u0256\41\0"+
    "\1\u0260\32\0\1\u0260\22\0\1\u0260\33\0\1\u0261\32\0"+
    "\1\u0261\106\0\1\u0262\32\0\1\u0262\11\0\1\u0262\26\0"+
    "\1\u01d6\133\0\1\u0263\32\0\1\u0263\22\0\1\u0263\54\0"+
    "\1\u0264\32\0\1\u0264\11\0\1\u0264\1\0\2\273\4\0"+
    "\113\273\2\267\4\0\113\267\44\0\1\u0265\32\0\1\u0265"+
    "\65\0\1\u0266\32\0\1\u0266\73\0\1\u0267\32\0\1\u0267"+
    "\11\0\1\u0267\50\0\1\u0268\32\0\1\u0268\62\0\1\u0269"+
    "\32\0\1\u0269\61\0\1\u026a\32\0\1\u026a\22\0\1\u026a"+
    "\2\0\2\265\4\0\113\265\2\262\4\0\113\262\47\0"+
    "\1\u026b\32\0\1\u026b\43\0\1\u0228\73\0\2\275\4\0"+
    "\113\275\44\0\1\u026c\32\0\1\u026c\46\0\1\u0246\73\0"+
    "\2\274\4\0\113\274";

  private static int [] zzUnpacktrans() {
    int [] result = new int[44550];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\0\1\11\103\1\2\0\12\1\1\11\6\1\10\11"+
    "\10\0\2\1\12\0\1\1\3\0\2\1\27\0\2\1"+
    "\3\0\1\1\3\0\1\11\3\1\1\11\2\0\1\1"+
    "\1\0\2\1\2\0\1\1\2\0\1\1\2\0\20\11"+
    "\3\0\1\1\1\0\1\1\26\0\1\1\5\0\1\1"+
    "\1\0\1\11\4\0\1\11\1\0\1\1\11\0\1\1"+
    "\40\0\1\1\5\0\1\11\36\0\1\1\31\0\1\11"+
    "\6\0\1\11\1\1\2\0\1\1\1\0\2\1\17\0"+
    "\1\1\16\0\1\1\17\0\1\11\3\0\1\11\17\0"+
    "\1\1\1\11\52\0\1\11\4\0\1\11\7\0\1\11"+
    "\2\0\1\11\15\0\2\11\5\0\1\11\13\0\1\1"+
    "\7\0\1\11\1\0\1\11\20\0\1\11\2\0\1\11"+
    "\5\0\1\11\1\0\1\1\4\0\1\11\3\0\1\11"+
    "\43\0\1\11\1\0\1\11\26\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[620];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	PartValidator() { }
		
	private boolean latinCheckOnly = false;	
	
	void setLatinCheckOnly(boolean latinCheckOnly) {
	
		this.latinCheckOnly = latinCheckOnly;
	}
	
	private StringBuilder pheader = new StringBuilder(); 
	
	private String pStart = "";
	
	int getSpaces() { return spaces.length(); }
	
	private int numero = 0;
	private int latin = 0;
	private int subNumber = 0;
	private String lettera = "";
	
	int getNumero() {
		return numero;
	}

	int getLatin() {
		return latin;
	}

	String getLettera() {
		return lettera;
	}
	
	private boolean intestazione = false;
	
	private void readLettera(String text) {
		
		lettera = text;
		
		//Prendi l'ultima lettera per il controllo sequenza
		//alcune liste dopo z hanno aa), bb), altre hanno ab), ac), ad)
		//Dopo z si accetta sia a che b
		//così come dopo i si accetta sia j che l e dopo v si accetta sia w che z
		
		int len = text.length();
		if(len > 1) text = text.substring(len-1,len);
		//if(text.length()==2) text = text.substring(1,2);
	
		if(text.equals("a")) numero = 1;
		if(text.equals("b")) numero = 2;
		if(text.equals("c")) numero = 3;
		if(text.equals("d")) numero = 4;
		if(text.equals("e")) numero = 5;
		if(text.equals("f")) numero = 6;
		if(text.equals("g")) numero = 7;
		if(text.equals("h")) numero = 8;
		if(text.equals("i")) numero = 9;
		if(text.equals("j")) numero = 10;
		if(text.equals("k")) numero = 11;
		if(text.equals("l")) numero = 12;
		if(text.equals("m")) numero = 13;
		if(text.equals("n")) numero = 14;
		if(text.equals("o")) numero = 15;
		if(text.equals("p")) numero = 16;
		if(text.equals("q")) numero = 17;
		if(text.equals("r")) numero = 18;
		if(text.equals("s")) numero = 19;
		if(text.equals("t")) numero = 20;
		if(text.equals("u")) numero = 21;
		if(text.equals("v")) numero = 22;
		if(text.equals("w")) numero = 23;
		if(text.equals("x")) numero = 24;
		if(text.equals("y")) numero = 25;
		if(text.equals("z")) numero = 26;
	
		//Non fare controllo sequenza per le lettere inglesi e le lettere doppie aa) bb) ab) e le eventuali altre combinazioni.. -- OLD
		if(numero == 0) numero = 99; 		
		
	}
	
	private void readNumero(String text) {
		
		if(numero == 0) {
	
			try {
			
				numero = Integer.valueOf(text);
				
			} catch (NumberFormatException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		} else {
		
			try {
			
				subNumber = Integer.valueOf(text);
				
			} catch (NumberFormatException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}		
	}
	
	private void append() {
	
		if(spaces.length() > 0) {
		
			pheader.append(spaces);
			spaces = "";
		}
			
		pheader.append(yytext());
		
		intestazione = true;
	}


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PartValidator(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
              {
                //System.out.println("PART_VALIDATOR EOF " + getMarkerDocument().getContext().getCurrentPartType() + " - " + numero + " - " + latin + " - " + lettera);
	
	if(getMarkerDocument().getContext().checkCurrentPart(numero, latin, subNumber, latinCheckOnly, pheader.toString())) {
	
		String id = getMarkerDocument().getContext().getCurrentPartId(numero, lettera, latin, subNumber);
		
		String tag = getMarkerDocument().getContext().getCurrentPartType();
		
		if(getMarkerDocument().getContext().getCurrentPartType().equalsIgnoreCase("allegato") ||
			getMarkerDocument().getContext().getCurrentPartType().equalsIgnoreCase("tabella")) {
		
			tag = "attachment";	
		}
		
		output.append("<mrk:" + tag + " id=\"" + id + "\">" + pStart + "<mrk:intestazione>" + pheader.toString() + "</mrk:intestazione>");
		//output.append("<mrk:" + tag + " id=\"" + id + "\"><mrk:intestazione>" + pheader.toString() + "</mrk:intestazione>");
	
	} else {
	
		output = null;
	}
	
	return YYEOF;
              }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { intestazione = true;

	pheader.append(spaces + yytext());
	
	spaces = "";
            }
          // fall through
          case 61: break;
          case 2:
            { if(intestazione) {
	
		spaces = yytext();
		 
	} else {
		
		output.append(yytext());
	}
            }
          // fall through
          case 62: break;
          case 3:
            { readNumero(yytext()); append();
            }
          // fall through
          case 63: break;
          case 4:
            { numero = Util.getIntegerFromRomanNumeral(yytext().toUpperCase()); append();
            }
          // fall through
          case 64: break;
          case 5:
            { numero = 1; append();
            }
          // fall through
          case 65: break;
          case 6:
            { numero = 2; append();
            }
          // fall through
          case 66: break;
          case 7:
            { numero = 3; append();
            }
          // fall through
          case 67: break;
          case 8:
            { numero = 4; append();
            }
          // fall through
          case 68: break;
          case 9:
            { numero = 5; append();
            }
          // fall through
          case 69: break;
          case 10:
            { numero = 6; append();
            }
          // fall through
          case 70: break;
          case 11:
            { numero = 7; append();
            }
          // fall through
          case 71: break;
          case 12:
            { numero = 8; append();
            }
          // fall through
          case 72: break;
          case 13:
            { numero = 9; append();
            }
          // fall through
          case 73: break;
          case 14:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -1);
            { readLettera(yytext()); append();
            }
          // fall through
          case 74: break;
          case 15:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -1);
            { if(getMarkerDocument().getContext().getCurrentPartType().equalsIgnoreCase("numeroLatino")) {
	
		numero = Util.getIntegerFromRomanNumeral(yytext().toUpperCase());
		
		lettera = yytext(); 
		
	} else {
		
		readLettera(yytext());
	} 
	
	append();
            }
          // fall through
          case 75: break;
          case 16:
            { numero = 10; append();
            }
          // fall through
          case 76: break;
          case 17:
            { numero = 11; append();
            }
          // fall through
          case 77: break;
          case 18:
            { numero = 12; append();
            }
          // fall through
          case 78: break;
          case 19:
            { numero = 13; append();
            }
          // fall through
          case 79: break;
          case 20:
            { numero = 14; append();
            }
          // fall through
          case 80: break;
          case 21:
            { numero = 15; append();
            }
          // fall through
          case 81: break;
          case 22:
            { numero = 16; append();
            }
          // fall through
          case 82: break;
          case 23:
            { numero = 17; append();
            }
          // fall through
          case 83: break;
          case 24:
            { numero = 18; append();
            }
          // fall through
          case 84: break;
          case 25:
            { numero = 19; append();
            }
          // fall through
          case 85: break;
          case 26:
            { numero = 20; append();
            }
          // fall through
          case 86: break;
          case 27:
            { numero = 21; append();
            }
          // fall through
          case 87: break;
          case 28:
            { numero = 22; append();
            }
          // fall through
          case 88: break;
          case 29:
            { numero = 23; append();
            }
          // fall through
          case 89: break;
          case 30:
            { numero = 24; append();
            }
          // fall through
          case 90: break;
          case 31:
            { numero = 25; append();
            }
          // fall through
          case 91: break;
          case 32:
            { latin = 2; append();
            }
          // fall through
          case 92: break;
          case 33:
            { latin = 3; append();
            }
          // fall through
          case 93: break;
          case 34:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -2);
            { readLettera(yytext()); append();
            }
          // fall through
          case 94: break;
          case 35:
            { append();
            }
          // fall through
          case 95: break;
          case 36:
            { pStart = yytext();
            }
          // fall through
          case 96: break;
          case 37:
            { latin = 1; append();
            }
          // fall through
          case 97: break;
          case 38:
            { latin = 10; append();
            }
          // fall through
          case 98: break;
          case 39:
            { latin = 9; append();
            }
          // fall through
          case 99: break;
          case 40:
            { latin = 8; append();
            }
          // fall through
          case 100: break;
          case 41:
            { latin = 4; append();
            }
          // fall through
          case 101: break;
          case 42:
            { latin = 6; append();
            }
          // fall through
          case 102: break;
          case 43:
            { latin = 20; append();
            }
          // fall through
          case 103: break;
          case 44:
            { latin = 7; append();
            }
          // fall through
          case 104: break;
          case 45:
            { latin = 16; append();
            }
          // fall through
          case 105: break;
          case 46:
            { latin = 11; append();
            }
          // fall through
          case 106: break;
          case 47:
            { latin = 21; append();
            }
          // fall through
          case 107: break;
          case 48:
            { numero = 9999; //codice per "unico"
	append();
            }
          // fall through
          case 108: break;
          case 49:
            { latin = 22; append();
            }
          // fall through
          case 109: break;
          case 50:
            { latin = 12; append();
            }
          // fall through
          case 110: break;
          case 51:
            { latin = 5; append();
            }
          // fall through
          case 111: break;
          case 52:
            { latin = 13; append();
            }
          // fall through
          case 112: break;
          case 53:
            { latin = 23; append();
            }
          // fall through
          case 113: break;
          case 54:
            { latin = 19; append();
            }
          // fall through
          case 114: break;
          case 55:
            { latin = 18; append();
            }
          // fall through
          case 115: break;
          case 56:
            { latin = 15; append();
            }
          // fall through
          case 116: break;
          case 57:
            { latin = 25; append();
            }
          // fall through
          case 117: break;
          case 58:
            { latin = 17; append();
            }
          // fall through
          case 118: break;
          case 59:
            { latin = 14; append();
            }
          // fall through
          case 119: break;
          case 60:
            { latin = 24; append();
            }
          // fall through
          case 120: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java PartValidator [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        PartValidator scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new PartValidator(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
